// JavaScript Document
function Cache( no_cache ){
    //
    this.oCache = new Object();

    if( arguments.length == 0 ){
        no_cache = false;
    }
    this.no_cache = no_cache;
}

/* funkcja, ktra dodaje sowo kluczowe do tablicy wartoci */
Cache.prototype.add = function(keyword, values){
  // twrzy nowy wpis w tablicy pamici podrcznej
  this.oCache[keyword] = new Array();
  // dodaje nowe wartoci sw kluczowych do pamici
  for(var i = 0; i < values.length; i++)
    this.oCache[keyword][i] = values[i];
}


/* funkcja, ktra sprawdza, czy sowo kluczowe jest ju w pamici lub prbuje
znale najdusze przedrostki z pamici do niego pasujce. Nastpnie dodaje
je do pamici, jako odpowiadajce wpisanemu sowu kluczowemu */
Cache.prototype.check = function ( keyword ){

  if( this.no_cache) return false;
  
  //sprawdza, czy sowo kluczowe jest ju w pamici
  if( this.oCache[keyword] ) return true;

  var keyword_lower = keyword.toLocaleLowerCase();

  // prbuje odnale najduszy przedrostek
  for( var i = keyword.length - 2; i >= 0; i-- ){
    // uzupenia biece sowo kluczowe
    var currentKeyword = keyword.substring(0, i + 1);
    
    // sprawdza, czy biecy przedrostek sowa kluczowego jest ju w pamici
    if( this.oCache[currentKeyword] ){
        // jeli jest w pamici
        var cacheResults = this.oCache[currentKeyword];
        // wyniki odpowiadajce biecemu sowu kluczowemu
        var keywordResults = new Array();
        var keywordResultsSize = 0;
        var cacheName = '';

        // prbuje odnale wszystkie sowa pasujce do biecego przedrostka
        for( var j = 0; j < cacheResults.length; j++ ){
            //cacheName = cacheResults[j];
            cacheName = cacheResults[j]['name'];

            if( (cacheName.toLocaleLowerCase()).indexOf(keyword_lower) == 0 )
              keywordResults[keywordResultsSize++] = cacheResults[j];
        }
        // dodaje wszystkie przedrostki sowa kluczowego do pamici
        this.add(keyword, keywordResults);
        return true;
    }
  }
  // nie znaleziono funkcji
  return false;
}

Cache.prototype.get = function(keyword){
    return this.oCache[keyword];
}

/* przeksztaca wszystkie obiekty potomne wza XML na tablic*/
Cache.prototype.fromXML = function (keyword, xmlRoot ){
  //pocztkuje zmienn resultsArray
  var idTab = xmlRoot.getElementsByTagName('id');
  var nameTab = xmlRoot.getElementsByTagName('name');
  
/*
  try{
    var ifAll = parseInt(xmlRoot.getElementsByTagName('all').item(0).firstChild.data);
  }catch(err){}
*/
  var resultsArray = new Array();
  if( nameTab.length == idTab.length ){
      // przeszukuje w ptli wszystkie wzy XML, pobierajc ich zawarto
      for(i = 0; i < nameTab.length; i++){
        resultsArray[i] = {
            'name' : nameTab.item(i).firstChild.data,
            'id'   : idTab.item(i).firstChild.data
        };
      }
  }else{
      // przeszukuje w ptli wszystkie wzy XML, pobierajc ich zawarto
      for(i = 0; i < nameTab.length; i++){
          resultsArray[i] = { 'name' : nameTab.item(i).firstChild.data, 'id'   : -1};
      }
  }
  //od razu dodaje do pamieci podrecznej
  this.oCache[keyword] = resultsArray;
  //zwracam tablice
  return resultsArray;
}
