/* chatURL - URL do aktualizacji wiadomoci */
var chatURL = "chat.php";
/* getColorURL - URL do pobrania wybranego koloru RGB */
var getColorURL = "get_color.php";
/* getEmotsURL - URL do pobrania ikonek emocji*/
var getEmotsURL = "chat.php?emots=1";
var emots_tab = [];
var emots_path = '';

/* tworzy obiekty XMLHttpRequest, ktre zaktualizuj wiadomoci rozmowy i pobior wybrany kolor*/
var xmlHttpGetMessages = createXmlHttpRequestObject();
var xmlHttpGetColor = createXmlHttpRequestObject();
var xmlHttpGetEmots = createXmlHttpRequestObject();
/* zmienna, ktra okrela jak czsto czy si z serwerem*/
var updateInterval = 1000; // w milisekundach
// ustawione na true, wywietla szczegowy komunikat o bdach
var debugMode = true;
/* rozpoczyna zapisywanie wiadomoci w pamici podrcznej */
var cache = new Array();
/* lastMessageID - tidentyfikator najwieszej wiadomoci rozmowy */
var lastMessageID = -1; 
/* mouseX, mouseY - wsprzdne kursora myszy */
var mouseX, mouseY;

/* ta funkcja rozpoczyna rozmow; jest wykonywana w chwili zaadowania strony */
function init(){
    // pobiera odwoanie do okna tekstowego, w ktrym uytkownik wpisuje now wiadomo
    var oMessageBox = document.getElementById("messageBox");
    // zapobiega uruchomieniu funkcji autouzupeniania
    oMessageBox.setAttribute("autocomplete", "off");
    // odwoanie do tekstu prbnego
    var oSampleText = document.getElementById("sampleText");
    // ustawia kolor domylny na czarny
    oSampleText.style.color = "black";
    // pobiera emot ikonki
    getEmots();
    // rozpoczyna aktualizacj nowego okna
    requestNewMessages();
}

/* funkcja wywoana po wciniciu przycisku "Wylij"*/
function sendMessage(){
  var time = '';
  var message = '';
  
  // zachowuje wiadomo w zmiennych lokalnych i czyci okienko tekstowe
  var oUserName = document.getElementById("userName");
  var oCurrentMessage = document.getElementById("messageBox");
  
  var odbiorca = parseInt(document.getElementById("odbiorcaSelect").value);
  var currentColor = document.getElementById("color").value;

  if( isNaN(odbiorca) || odbiorca <= 0){
      alert('Prosz wybierz uytkownika do ktrego chcesz napisa!');
      return false;

  }
  // nie wysya pustych wiadomoci
  if ( trim(oCurrentMessage.value) != ""  ){
    // jeli musimy wysa i pobra wiadomo
    params =  "ajax=1" +
              "&mode=SendAndRetrieveNew" +
              "&color=" + encodeURIComponent(currentColor) + 
              "&odbiorca=" + encodeURIComponent(odbiorca) +
              "&message=" + oCurrentMessage.value;
              
    // dodaje wiadomo do kolejki
    cache.push(params);

    var htmlMessage = "";
    htmlMessage += "<div class=\"wyslana\" >\n";
    htmlMessage += "  <div class=clock>" + '00:00:00' + "</div>\n" ;
    htmlMessage += "  <div class=autor>" + htmlspecialchars(oUserName.value) + "</div>\n" ;
    htmlMessage += "  <div class=tresc>" + replace_emots( htmlspecialchars( oCurrentMessage.value ) ) + "</div>\n";
    htmlMessage += "</div>\n\n";
    // wywietla wiadomo
    displayMessage (htmlMessage);
    
    // czyci okno tekstowe
    oCurrentMessage.value = "";
  }
}

/* funkcja wywoana po wciniciu przycisku "Usu wszystko" */
function deleteMessages()
{
  // ustawia flag, ktra okrela, e wiadomoci s usuwane
  params = "ajax=1&mode=DeleteAndRetrieveNew";
  // dodaje wiadomo do kolejki
  cache.push(params);
}

/* wysya asynchroniczne danie, aby pobra nowe wiadomoci, wysa je lub usun*/
function requestNewMessages()
{  
  // pobiera nazw uytkownika i kolor ze strony
  var currentUser = document.getElementById("userName").value;
  var currentColor = document.getElementById("color").value;
  // kontynuuje jeli xmlHttpGetMessages nie jest pusty
  if(xmlHttpGetMessages)
  {
    try
    {
      // nie zaczyna nowej operacji na serwerze, jeli jaka jest wykonywana
      if (xmlHttpGetMessages.readyState == 4 || 
          xmlHttpGetMessages.readyState == 0) 
      {
        // przechowa parametry potrzebne do wykonania dania na serwerze
        var params = "";
        // jeli w kolejce czekaj wiadomoci, to pobiera najstarsz
        if (cache.length>0)
          params = cache.shift();
        // jeli pami jest pusta, pobiera now wiadomo
        else
          params = "ajax=1&mode=RetrieveNew" +
                   "&id=" +lastMessageID;
        // wywouje dziaania po stronie serwera
        xmlHttpGetMessages.open("POST", chatURL, true);
        xmlHttpGetMessages.setRequestHeader("Content-Type", 
                                   "application/x-www-form-urlencoded");
        xmlHttpGetMessages.onreadystatechange = handleReceivingMessages;
 
        xmlHttpGetMessages.send(params);
      }
      else
      {
        // sprawdza ponownie czy s nowe wiadomoci
        setTimeout("requestNewMessages();", updateInterval);
      }
    }
    catch(e){
      displayError(e.toString());
    }
  }else{
      displayError('Nie ma obiektu: xmlHttpGetMessages');
  }
}

/* funkcja obsugujca odpowied HTTP podczas aktualizacji wiadomoci*/
function handleReceivingMessages() 
{
  // kontynuuje jeli proces jest zakoczony
  if (xmlHttpGetMessages.readyState == 4) 
  {
    // kontynuuje, jeli status HTTP ma warto "OK"
    if (xmlHttpGetMessages.status == 200) 
    {
      try
      {
        // przetwarza odpowied serwera
        readMessages();
      }
      catch(e)
      {
        // wywietla wiadomo o bdzie
        displayError(e.toString());
      }
    } 
    else
    {
      // wywietla wiadomo o bdzie
      displayError(xmlHttpGetMessages.statusText);
    }
  }
}

/* funkcja obsugujca odpowied serwera podczas aktualizacji wiadomoci*/
function readMessages()
{  
  // pobiera odpowied serwera
  var response = xmlHttpGetMessages.responseText;
  // bd serwera?
  if (response.indexOf("ERRNO") >= 0 || response.indexOf("bd:") >= 0 || response.length == 0)
    throw(response.length == 0 ? "Pusta odpowied serwera." : response);
  // pobiera element dokumentu
  response = xmlHttpGetMessages.responseXML.documentElement;
  // pobiera flag okrelajc czy okno rozmowy zostao wyczyszczone czy nie
/*
  clearChat = response.getElementsByTagName("clear").item(0).firstChild.data;
  // jeli flaga ma warto true, trzeba wyczyci okno wiadomoci
  if(clearChat == "true")
  {
    // czyci okno wiadomoci i zeruje id
    document.getElementById("scroll").innerHTML = "";
    lastMessageID = -1;
  }
*/
  // pobiera tablice z odpowiedzi serwera
  idArray    = response.getElementsByTagName("id");
  colorArray = response.getElementsByTagName("color");
  nameArray  = response.getElementsByTagName("name");
  timeArray  = response.getElementsByTagName("time");
  messageArray = response.getElementsByTagName("message");
  // dodaje now wiadomo do okna rozmowy
  displayMessages(idArray, colorArray, nameArray, timeArray, messageArray);
  // przechowuje lokalnie ID ostatniej otrzymanej wiadomoci
  if(idArray.length>0)
    lastMessageID = idArray.item(idArray.length - 1).firstChild.data;
  // ponownie uruchamia sekwencj
  setTimeout("requestNewMessages();", updateInterval);
}

/* funkcja dodajca nowe wiadomoci do okna rozmowy */
function displayMessages(idArray, colorArray, nameArray, timeArray, messageArray)
{
  // kady przebieg ptli dodaje now wiadomo
  for(var i=0; i<idArray.length; i++)
  {
    // pobiera szczegy wiadomoci
    var color = colorArray.item(i).firstChild.data.toString();
    var time = timeArray.item(i).firstChild.data.toString();
    var name = nameArray.item(i).firstChild.data.toString();
    var message = messageArray.item(i).firstChild.data.toString();
    // tworzy kod HTML, ktry wywietli wiadomo
    var htmlMessage = "";
    htmlMessage += "<div class=\"odebrana\" >";
    htmlMessage += "  <div class=clock>" + time + "</div>\n" ;
    htmlMessage += "  <div class=autor>" + name + "</div>\n" ;
    htmlMessage += "  <div class=tresc>" + replace_emots(message.toString()) + "</div>\n";
    htmlMessage += "</div>";
    // wywietla wiadomo
    displayMessage (htmlMessage);
  }
}
// wywietla wiadomo
function displayMessage(message, type)
{
  // pobiera obiekt scroll
  var oScroll = document.getElementById("scroll");
  // sprawdza, czy pasek jest przewinity
  var scrollDown = (oScroll.scrollHeight - oScroll.scrollTop <= oScroll.offsetHeight );

  // wywietla wiadomo
  oScroll.innerHTML += message;
  // przewija na d pasek przewijania
  oScroll.scrollTop = scrollDown ? oScroll.scrollHeight : oScroll.scrollTop;
}


/*obsuguje zdarzenie keydown aby okreli, kiedy wcinito Enter*/ 
function handleKey(e) 
{
  // pobiera zdarzenie
  e = (!e) ? window.event : e;
  // pobiera kod wcinitego znaku
  code = (e.charCode) ? e.charCode : ((e.keyCode) ? e.keyCode :
    ((e.which) ? e.which : 0));
  // obsuguje zdarzenie keydown
  if (e.type == "keydown") 
  {
    // jeli zosta wcinity Enter (kod 13) 
    if(code == 13)
    {
      // wysya biec wiadomo
      sendMessage();
    }
  }
}

/* funkcja, ktra oblicza wsprzdne kursora na stronie*/
function getMouseXY(e) 
{
  // specyficzne dla przegldarki 
  if(window.ActiveXObject)
  {
    mouseX = window.event.x + document.body.scrollLeft;
    mouseY = window.event.y + document.body.scrollTop;    
  }
  else
  {
    mouseX = e.pageX;
    mouseY = e.pageY;
  }
}

/* wywoanie serwera do pobrania koloru RGB*/
function getColor(e)
{
  getMouseXY(e);
  
  // nic nie robi, jeli obiekt XMLHttpRequest ma warto null
  if(xmlHttpGetColor)
  {
    // rozpoczyna ustalanie wzgldnej pozycji myszy
    var offsetX = mouseX;
    var offsetY = mouseY;
    // pobiera odwoania
    var oPalette = document.getElementById("palette");
    var oTd = document.getElementById("colorpicker");  
    // oblicza wzgldn pozycj kursora  w oknie
    if(window.ActiveXObject){
      offsetX = window.event.offsetX;
      offsetY = window.event.offsetY;  
    }else{
      offsetX -= oPalette.offsetLeft + oTd.offsetLeft;
      offsetY -= oPalette.offsetTop + oTd.offsetTop;
 
    }
    
    
    // wywouje serwer asynchronicznie, aby pobra wybrany kolor
    try
    {
      if (xmlHttpGetColor.readyState == 4 || 
          xmlHttpGetColor.readyState == 0) 
      {
        params = "?offsetx=" + offsetX + "&offsety=" + offsetY;        
        xmlHttpGetColor.open("GET", getColorURL+params, true);    
        xmlHttpGetColor.onreadystatechange = handleGettingColor;
        xmlHttpGetColor.send(null);    
      }
    }
    catch(e)
    {
      // wywietla komunikat o bdzie
      displayError(xmlHttp.statusText);
    }
  }
}
/* funkcja obsugujca odpowied HTTP */
function handleGettingColor() 
{
  // jeli proces zostanie zakoczony, decyduje co zrobi ze zwrconymi danymi
  if (xmlHttpGetColor.readyState == 4) 
  {
    // tylko jeli status HTTP jest "OK"
    if (xmlHttpGetColor.status == 200) 
    {
      try
      {
        //zmienia kolor
        changeColor();
      }
      catch(e)
      {
        // wywietla komunikat o bdzie
        displayError(xmlHttpGetColor.statusText);
      }
    } 
    else
    {
      // wywietla komunikat o bdzie
      displayError(xmlHttpGetColor.statusText);
    }        
  }
}
/* funkcja, ktra zmienia kolor wywietlanej wiadomoci*/
function changeColor()
{
  response=xmlHttpGetColor.responseText;
  // bd serwera?
  if (response.indexOf("ERRNO") >= 0 || response.indexOf("error:") >= 0
    || response.length == 0)
    throw(response.length == 0 ? "Nie mog zmieni koloru!" : response);
  // zmienia kolor
  var oColor = document.getElementById("color");
  var oSampleText = document.getElementById("sampleText");
  oColor.value = response;
  oSampleText.style.color = response;
}




/* wywoanie serwera do pobrania koloru RGB*/
function getEmots(){
  debug.pisz('pobieram emots ikonki');
  
  // nic nie robi, jeli obiekt XMLHttpRequest ma warto null
  if( xmlHttpGetEmots ){
    // wywouje serwer asynchronicznie, aby pobra wybrany kolor
    try{
      if (xmlHttpGetEmots.readyState == 4 || xmlHttpGetEmots.readyState == 0){
        debug.pisz('Wysyam zapytanie');
        
        xmlHttpGetEmots.open("GET", getEmotsURL, true);
        xmlHttpGetEmots.onreadystatechange = handleGettingEmots;
        xmlHttpGetEmots.send(null);
      }
    }catch(e){
      // wywietla komunikat o bdzie
      displayError(xmlHttpGetEmots.statusText);
    }
  }
}
/* funkcja obsugujca odpowied HTTP */
function handleGettingEmots(){
  
  // jeli proces zostanie zakoczony, decyduje co zrobi ze zwrconymi danymi
  if (xmlHttpGetEmots.readyState == 4){
    debug.pisz('Odbieram odp z serwera' + xmlHttpGetEmots.readyState);
    
    // tylko jeli status HTTP jest "OK"
    if (xmlHttpGetEmots.status == 200){
      try{
        debug.pisz('wyswietlam ikonki');
        //zmienia kolor
        displayEmots();
      }catch(e){
        // wywietla komunikat o bdzie
        displayError(e.toString());
      }
    }else{
      // wywietla komunikat o bdzie
      displayError(xmlHttpGetEmots.statusText);
    }
  }
}
/* funkcja, ktra zmienia kolor wywietlanej wiadomoci*/
function displayEmots(){
  response = xmlHttpGetEmots.responseText;
  
  // bd serwera?
  if ( response.indexOf("ERRNO") >= 0 || response.indexOf("error:") >= 0 || response.length == 0 ) throw("Nie mog pobra ikonek emocji!");
  

  var line = '';
  var pos = response.indexOf('\n');
  var pos2 = 0;
  var parts = [];
  var i = 0;
  var cols = 8;

  //w pierwszej linii jest sciezka do emot ikonek bez koczacego slasha
  emots_path = trim( response.substring(0, pos));
  response = response.substring(pos + 1);
  pos = response.indexOf('\n');
  
  var htmlEmots = '<table cellpadding=0 cellspacing=0 bgcolor=#FFFF9B borderolor=#D4D0C8 border=1>\n';

  htmlEmots += "<tr>\n";
  while( pos > 0 ){
      line = trim( response.substring(0, pos) );
      response = response.substring(pos + 1);

      parts = line.split(',');

      htmlEmots += "<td align=center>\n";

      if( parts.length == 3 ){
          htmlEmots += "<img src=\""+ emots_path + parts[2] + "\" alt=\"" + parts[0] + "\" onmouseover=\"zamien(this,'" + emots_path + parts[1] + "')\" onmouseout=\"zamien(this,'" + emots_path + parts[2] + "')\" onclick=\"addImg(this);\" style=\"cursor:pointer;\" >\n";
      }else{
          htmlEmots += "<img src=\""+ emots_path + parts[1] + "\" alt=\"" + parts[0] + "\" style=\"cursor:pointer;\" onclick=\"addImg(this);\" >\n";
          parts[2] = new String('');
      }
      
      htmlEmots += "</td>\n";
     
      emots_tab[i] = { 'str' : htmlspecialchars(parts[0]), 'gif' : parts[1], 'gif_' : parts[2]};

      i++;
      
      if( (i % cols) == 0){
          htmlEmots += "</TR>\n\n<tr>\n";
      }
      pos = response.indexOf('\n');
  }
  
  if( ( i % cols ) != 0){
      htmlEmots += "<td colspan=" + (i%cols) + ">&nbsp;</td>\n";
      htmlEmots += "</TR>\n";
  }
  htmlEmots += "<tr><td colspan="+cols+" align=center onclick=\"ukryj(document.getElementById('emots'));\"><b>Zamknij</TD></TR>";
  htmlEmots += '</table>\n';
  
  // zmienia kolor
  document.getElementById('emots').innerHTML = htmlEmots;
}

function zamien(el, zmiana){
    el.src = zmiana;
}

function addImg( el ){
    var oEmots = document.getElementById('emots');
    var oCurrentMessage = document.getElementById("messageBox");
    
    oCurrentMessage.value += " " + el.alt + " ";

    ukryj(oEmots);

    document.onmousedown = old_onmousedown;

    //licz();
}

function pokazEmots(element, event){
  var el;

  if (document.getElementById)
      el = document.getElementById('emots');
  else
      alert("Niestety twoja przegldarka nie obsuguje standardu DOM.\n");

  wysrodkuj(el);
  pokaz(el);
  
  old_onmousedown = document.onmousedown;
  document.onmousedown = ukryjOnMouseDown;
}

function ukryjOnMouseDown(e){
    var el=document.getElementById('emots');
    var top=0;var left=0;var right=0;var bottom=0;var x=0;var y=0;

    if( !e ) e = window.event;

    top    = parseInt(el.style.top);
    left   = parseInt(el.style.left);
    right  = left+parseInt(el.scrollWidth);
    bottom = top+parseInt(el.scrollHeight);
    x = parseInt(document.body.scrollLeft)+parseInt(e.clientX);
    y = parseInt(document.body.scrollTop)+parseInt(e.clientY);

//jeli nie kliknieto na tabelce ukryj ja w przeciwnym wypadku dodaj buke
    if( (x<left) || (x>right) || (y<top) || (y>bottom) ){
	    ukryj(el);
    	document.onmousedown = old_onmousedown;
	  }
}


function replace_emots( msg ){
    var i = 0;
    var replace = '';
    

    for ( i =0; i < emots_tab.length; i++ ){
        if( emots_tab[i].gif_.length > 0 ){
            replace = '<img src="'+ emots_path + emots_tab[i].gif_ +'" alt="' + emots_tab[i].str + '"/>';
            msg = str_ireplace(emots_tab[i].str, replace, msg);
        }else{
            replace = '<img src="'+ emots_path + emots_tab[i].gif +'" alt="' + emots_tab[i].str + '"/>';
            msg = str_ireplace(emots_tab[i].str, replace, msg);
        }
    }

    return msg;
    
}

function str_replace(search, replace, subject ){
    var pos = subject.indexOf( search );
    var str = '';
    
    while( pos  >= 0 ){
        str += subject.substring(0, pos) + replace;
        subject = subject.substring(pos + search.length);
        pos = subject.indexOf(search);
    }
    str += subject;
    
    return str;
}

function str_ireplace(search, replace, subject ){
    var search_small  = search.toLowerCase();
    var subject_small = subject.toLowerCase();
    var pos = subject_small.indexOf( search_small );
    var str = '';

    while( pos  >= 0 ){
        str += subject.substring(0, pos) + replace;
        subject = subject.substring(pos + search.length);
        subject_small = subject_small.substring(pos + search.length);
        var pos = subject_small.indexOf( search_small );
    }
    str += subject;
    
    return str;
}


function print_emots(){
    var i = 0;

    for ( i =0; i < emots_tab.length; i++ ){
        debug.pisz(i + '. ' + emots_tab[i].str + ', ' + emots_tab[i].gif + ', '+ emots_tab[i].gif_);
    }
}


var ENT_NOQUOTES = 1;
var ENT_QUOTES = 2;

function htmlspecialchars( str, flag ){

  if( arguments.length == 1 ){
      flag = 0;
  }
  
/*
 The translations performed are:

    * '&' (ampersand) becomes '&amp;'
    * '"' (double quote) becomes '&quot;' when ENT_NOQUOTES is not set.
    * ''' (single quote) becomes '&#039;' only when ENT_QUOTES is set.
    * '<' (less than) becomes '&lt;'
    * '>' (greater than) becomes '&gt;'
*/
  str = str_replace("&", "&amp;", str);
  str = str_replace("<", "&lt;", str);
  str = str_replace(">", "&gt;", str);

  if( flag & ENT_NOQUOTES == 0){
    str = str_replace('"', '&quot;', str);
  }
  
  if( flag & ENT_NOQUOTES != 0 ){
    str = str_replace("'", "&#039;", str);
  }

  return str;
}
