if (!Array.prototype.push) {
    Array.prototype.push = function() {
        for (var i = 0; i < arguments.length; ++i)
            this[this.length] = arguments[i];
        return this.length;
    };
}
if (!Array.prototype.shift) {
    Array.prototype.shift = function() {
        var first;
        if (this.length) {
            first = this[0];
            for (var i = 0; i < this.length - 1; ++i)
                this[i] = this[i + 1];
            this.length -= 1;
        }
        return first;
    };
}

var browser	= navigator.userAgent.toLowerCase(),
	//isOpera = (browser.indexOf("opera") > -1),
	isOpera = window.opera,
	isIE 	= ((browser.indexOf("msie") > -1) && !isOpera),
	isIE5 	= ((browser.indexOf("msie 5") > -1) && !isOpera),
	isIE55 	= (/msie 5\.[56789]/i.test(navigator.userAgent) && !isOpera),
	isMac 	= (browser.indexOf("mac") > -1),
	isLinux = (browser.indexOf("linux") > -1),
	isGecko	= (browser.indexOf("gecko") > -1),
	isSafari = (browser.indexOf("safari") > -1);

function browserVer (str, prefix) {
	var i = str.indexOf(prefix);
	if (i != -1) {
		var ver = parseFloat(str.substring(i + prefix.length));
		if (!isNaN(ver))
			return ver;
	}
	return null;
}

function browserSupported () {
	if ((isGecko && (
			((v=browserVer(browser, "firefox/")) >= 1.5)
			|| ((v=browserVer(browser, "camino/")) >= 1)
		))
		|| (isSafari && (v=browserVer(browser, "safari/")) >= 1.3)
		|| (isIE && (v=browserVer(browser, "msie "))>=6)
		|| (isLinux && !isOpera)
		|| (!isLinux && isOpera && ((v=browserVer(browser, "opera/"))>=9 || (v=browserVer(browser, "opera "))>=9))
	) {
		return true;
	} else
		return false;
}

var Class = {
	create: function() {
		return function() { this.init.apply (this, arguments); }
	}
};

function $ () {
	var elements = new Array(),
		e, i, imax;
	for (i=0, imax=arguments.length; i<imax; i++) {
		e = arguments[i];
		if (typeof(e) == 'string')
			e = document.getElementById(e);

		if (imax == 1)
      		return e;

		elements.push(e);
	}
	return elements;
}

function $A (iterable) {
	if (!iterable)
		return [];
	if (iterable.toArray) {
		return iterable.toArray();
	} else {
		var r = [], i, imax;
		for (i=0, imax=iterable.length; i<imax; i++)
			r.push (iterable[i]);
		return r;
	}
}

Function.prototype.bindAsEventListener = function (object) {
	var __method = this,
		args = $A(arguments);
	object = args.shift();
	return function (event) { return __method.apply(object, [( event || window.event)].concat(args).concat($A(arguments))); }
};

String.prototype.toCamel = function () {
	var splitted = this.split('-');
	if (splitted.length == 1)
		return splitted[0];
	var camelized = (this.indexOf('-') == 0
			? splitted[0].charAt(0).toUpperCase() + splitted[0].substring(1)
			: splitted[0]),
		i, imax, s;
	for (i=1, imax=splitted.length; i<imax; i++) {
		s = splitted[i];
		camelized += s.charAt(0).toUpperCase() + s.substring(1);
	}
	return camelized;
};

String.prototype.trim = function() {
	return this.replace(/^\s+|\s+$/, '');
};

Array.prototype.exists = function (el) {
	for (var i=0, imax=this.length; i<imax; i++)
		if (el == this[i])
			return true;
	return false;
};

var Event = {
	element: function (event) {
		return event.target || event.srcElement;
	},

    stop: function (event) {
        this.stopPropagation (event);
        this.preventDefault (event);
    },

    stopPropagation: function (event) {
        if (event.stopPropagation) {
            event.stopPropagation();
        } else {
            event.cancelBubble = true;
        }
    },

    preventDefault: function (event) {
        if (event.preventDefault) {
            event.preventDefault();
        } else {
            event.returnValue = false;
        }
    },

	observers: false,

	_observeAndCache: function (element, name, observer, useCapture) {
		if (!this.observers)
			this.observers = [];
		if (element.addEventListener) {
			this.observers.push ([element, name, observer, useCapture]);
			element.addEventListener(name, observer, useCapture);
		} else if (element.attachEvent) {
			this.observers.push ([element, name, observer, useCapture]);
			element.attachEvent ('on' + name, observer);
		}
	},

	unloadCache: function () {
		if (!Event.observers)
			return;
		for (var i=0, imax=Event.observers.length; i<imax; i++) {
			Event.stopObserving.apply (this, Event.observers[i]);
			Event.observers[i][0] = null;
		}
		Event.observers = false;
	},

	observe: function (e, name, observer, useCapture) {
		if (typeof(e)!='string' && !(e=$(e))) return false;
		useCapture = useCapture || false;
		if (name == 'keypress' && (navigator.appVersion.match(/Konqueror|Safari|KHTML/)	|| e.attachEvent))
			name = 'keydown';
		Event._observeAndCache (e, name, observer, useCapture);
	},

	stopObserving: function (element, name, observer, useCapture) {
		element = $(element);
		useCapture = useCapture || false;

		if (name == 'keypress' && (navigator.appVersion.match(/Konqueror|Safari|KHTML/) || element.detachEvent))
			name = 'keydown';

		if (element.removeEventListener) {
			element.removeEventListener (name, observer, useCapture);
		} else if (element.detachEvent) {
			try {
				element.detachEvent ('on' + name, observer);
			} catch (e) {}
		}
	}
};

function isDefined () {
	for (var i=0, imax=arguments.length; i<imax; ++i)
		if (typeof(arguments[i]) == 'undefined')
			return false;
	return true;
}

function isString () {
	for (var i=0, imax=arguments.length; i<imax; ++i)
		if (typeof(arguments[i]) != 'string')
			return false;
	return true;
}

function isNumber () {
	for (var i=0, imax=arguments.length; i<imax; ++i)
		if (isNaN(arguments[i]) || typeof(arguments[i])!='number')
			return false;
	return true;
}

function myDisplay (e, show) {
	if (!(e = $(e))) return 0;
	mySetStyle (e, {'display':(((show == undefined && myGetStyle (e, 'display') == 'none') || show)
		? 'block'
		: 'none'
	)});
	return true;
}

function myGetStyle (e, style, bInt) {
    if (!(e=$(e))) return false;
	var dv = document.defaultView,
    	camelizedStyle = (style == 'float'
			? (typeof e.style.styleFloat != 'undefined' ? 'styleFloat' : 'cssFloat')
			: style
		).toCamel(),
    	v = e.style[camelizedStyle],
		css;
	if (!v) {
    	if (dv && dv.getComputedStyle) {
        	css = dv.getComputedStyle (e, null);
        	v = css ? css[camelizedStyle] : null;
      	} else if (e.currentStyle) {
       		v = e.currentStyle[camelizedStyle];
      	}
    }

    if((v == 'auto') && ['width','height'].exists(style) && (e.getStyle('display') != 'none'))
    	v = e['offset'+style.toCamel()] + 'px';

    if (window.opera && ['left', 'top', 'right', 'bottom'].exists(style))
    	if (e.getStyle(e, 'position') == 'static')
			v = 'auto';
    return v == 'auto' ? null : (bInt ? (parseInt(v) || 0) : v);
}

function mySetStyle (e, styles) {
	if (!(e=$(e))) return false;
	var n;
	for (n in styles)
		e.style[n.toCamel()] = styles[n];
	return e;
}

function mySetOpacity (e, v) {
	if (!(e=$(e))) return false;
	if (v == 1) {
    	v = (/Gecko/.test(navigator.userAgent) && !/Konqueror|Safari|KHTML/.test(navigator.userAgent)) ? 0.999999 : 1.0;
    	if(/MSIE/.test(navigator.userAgent) && !window.opera)
			e.style.filter = myGetStyle(e, 'filter').replace(/alpha\([^\)]*\)/gi,'');
			var f = myGetStyle(e, 'filter');
			if (f != undefined)
				mySetStyle (e, {'filter':f.replace(/alpha\([^\)]*\)/gi,'')});
	} else {
		if(v < 0.00001)
			v = 0;
		if(/MSIE/.test(navigator.userAgent) && !window.opera) {
			var f = myGetStyle(e, 'filter');
			f = (f == undefined) ? '' : f.replace(/alpha\([^\)]*\)/gi,'');
			mySetStyle (e, {'filter':f+'alpha(opacity='+v*100+')'});
		}
	}
	return mySetStyle (e, {'opacity':v}) ? true : false;
}

function myTop (e, iY) {
	if (!(e = $(e))) return 0;
	if(isDefined(e.style)) {
		if (isDefined(e.style.top)) {
			if (isNumber(iY))
				mySetStyle (e, {'top':iY+'px'});
			else
				iY = myGetStyle (e,'top',true);
		}
		else if (isDefined(e.style.pixelTop)) {
			if (isNumber(iY))
				mySetStyle (e, {'pixelTop':iY});
			else
				iY = myGetStyle (e,'pixelTop');
		}
	}
	return iY || 0;
}

function myLeft (e, iX) {
	if (!(e=$(e))) return 0;
	if (isDefined(e.style)) {
		if (isDefined(e.style.left)) {
			if (isNumber(iX))
				mySetStyle (e, {'left':iX+'px'});
			else
				iX = myGetStyle (e,'left',true);
		} else if (isDefined(e.style.pixelLeft)) {
			if (isNumber(iX))
				mySetStyle (e, {'pixelLeft':iX});
			else
				iX = myGetStyle (e,'pixelLeft');
		}
	}
	return iX || 0;
}

function myViewSize () {
	var x,y;
	// wszystko poza IE
	if (self.innerHeight) {
		x = self.innerWidth;
		y = self.innerHeight;
	}
	// IE 6 Strict Mode
	else if (document.documentElement && document.documentElement.clientHeight) {
		x = document.documentElement.clientWidth;
		y = document.documentElement.clientHeight;
	}
	// pozostale IE
	else if (document.body) {
		x = document.body.clientWidth;
		y = document.body.clientHeight;
	}
	return new Array (x, y);
}

function myPageSize () {
	var x,y,
		b = document.body,
		test1 = b.scrollHeight,
		test2 = b.offsetHeight;

	// wszystko poza IE Mac
	if (test1 > test2) {
		x = b.scrollWidth;
		y = b.scrollHeight;
	}
	// IE Mac (zadziala takze dla IE 6 Strict Mode, Mozilla, Safari)
	else {
		x = b.offsetWidth;
		y = b.offsetHeight;
	}

	// gdy wymiary strony sa mniejsze od wymiarow okna
	winSize = myViewSize();
	y = (y < winSize[1]) ? winSize[1] : y;
	x = (x < winSize[0]) ? winSize[0] : x;

	return new Array (x, y);
}

function myScrollSize () {
	var x,y;
	// wszystko poza IE
	if (self.pageYOffset) {
		x = self.pageXOffset;
		y = self.pageYOffset;
	}
	// IE 6 Strict
	else if (document.documentElement && document.documentElement.scrollTop) {
		x = document.documentElement.scrollLeft;
		y = document.documentElement.scrollTop;
	}
	// pozostale IE
	else if (document.body) {
		x = document.body.scrollLeft;
		y = document.body.scrollTop;
	}
	return new Array (x, y);
}

function myWidth (e, w) {
	if (!(e = $(e))) return 0;
	w = (isNumber(w)) ? ((w<0) ? 0 : Math.round(w)) : -1;
	var css = isDefined(e.style);
	if (e == document || e.tagName.toLowerCase() == 'html' || e.tagName.toLowerCase() == 'body') {
		var pageSize = myPageSize ();
		w = pageSize[0];
	}
	else if (css && isDefined(e.offsetWidth) && isString(e.style.width)) {
		if (w>=0) {
			var pl=0, pr=0, bl=0, br=0;
			if (document.compatMode == 'CSS1Compat') {
				pl = myGetStyle (e,'padding-left',1);
				if (pl !== null) {
					pr = myGetStyle (e,'padding-right',1);
					bl = myGetStyle (e,'border-left-width',1);
					br = myGetStyle (e,'border-right-width',1);
				}
				// getComputedStyle and currentStyle jeszcze nie istnieje
				else if (isDefined(e.offsetWidth, e.style.width)){
					e.style.width = w+'px';
					pl = e.offsetWidth-w;
				}
			}
			w -= (pl+pr+bl+br);
			if (isNaN(w) || w<0)
				return 0;
			else
				e.style.width = w+'px';
		}
		w = e.offsetWidth;
	}
	else if (css && isDefined(e.style.pixelWidth)) {
		if (w>=0)
			e.style.pixelWidth = w;
		w = e.style.pixelWidth;
	}
	return w || 0;
}

function myHeight (e, h) {
	if (!(e = $(e))) return 0;
	h = isNumber(h) ? (h<0 ? 0 : Math.round(h)) : -1;
	var css = isDefined(e.style);
	if (e == document || e.tagName.toLowerCase() == 'html' || e.tagName.toLowerCase() == 'body') {
		var pageSize = myPageSize ();
		h = pageSize[1];
	}
	else if (css && isDefined(e.offsetHeight) && isString(e.style.height)) {
		if (h>=0) {
			var pt=0, pb=0, bt=0, bb=0;
			if (document.compatMode == 'CSS1Compat') {
				pt = myGetStyle (e,'padding-top',1);
				if (pt !== null) {
					pb = myGetStyle (e,'padding-bottom',1);
					bt = myGetStyle (e,'border-top-width',1);
					bb = myGetStyle (e,'border-bottom-width',1);
				}
				// getComputedStyle & currentStyle jeszcze nie istnieje
				else if (isDefined(e.offsetHeight, e.style.height)){
					e.style.height = h+'px';
					pt = e.offsetHeight-h;
				}
			}
			h -= (pt+pb+bt+bb);
			if (isNaN(h) || h<0)
				return 0;
			else
				e.style.height = h+'px';
		}
		h = e.offsetHeight;
	}
	else if (css && isDefined(e.style.pixelHeight)) {
		if (h>=0)
			e.style.pixelHeight = h;
		h = e.style.pixelHeight;
	}
	return h || 0;
}

var WaitDiv = Class.create();
WaitDiv.prototype = {

	init: function () {
		this.div;
		this.msg;
		this.parentNode = document.body;
		this.waitDivFlash;

		if (!(this.waitDivFlash=$('waitDivFlash'))) {
			this.waitDivFlash = document.createElement('div');
			var flashWidth = window.opera ? 1 : 175,
				flashHeight = window.opera ? 1 : 125;
			this.waitDivFlash.setAttribute ('id', 'waitDivFlash');
			mySetStyle (this.waitDivFlash, (window.opera ? {'visibility':'hidden'} : {'display':'none'}));
			this.waitDivFlash.innerHTML = '<object classid="clsid:D27CDB6E-AE6D-11cf-96B8-444553540000" codebase="https://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=5,0,0,0" width="'+flashWidth+'" height="'+flashHeight+'">'
				+'<param name=movie value="/gfx/flash/loading.swf">'
				+'<param name=quality value=high>'
				+'<param name=menu value=false>'
				+'<param name=wmode value=transparent>'
				+'<embed src="/gfx/flash/loading.swf" quality=high pluginspage="https://www.macromedia.com/shockwave/download/index.cgi?P1_Prod_Version=ShockwaveFlash" type="application/x-shockwave-flash" width="'+flashWidth+'" height="'+flashHeight+'" wmode="transparent"></embed>'
				+'</object>';
			document.body.appendChild (this.waitDivFlash);
		}
	},

	create: function () {
		var pageSize = myPageSize(),
			viewSize = myViewSize();

		this.top = 0;
		this.left = 0;
		this.width = pageSize[0];
		this.height = pageSize[1];
		this.centerX = viewSize[0]/2;
		this.centerY = viewSize[1]/2;

		// waitDiv
		this.div = document.createElement ('div');
		this.div.className = 'waitDiv';

		// waitDivBg
		this.bg = document.createElement ('div');
		this.bg.className = 'waitDivBg';

		// waitDivInner
		inner = document.createElement ('div');
		inner.className = 'waitDivInner';
		mySetStyle (inner, {'visibility':'hidden'});

		// przeskalowac do oryginalnych rozmiarow
		if (window.opera) {
			var waitDivFlashObj = this.waitDivFlash.childNodes[0],
				waitDivFlashEmbed = waitDivFlashObj.getElementsByTagName('embed')[0];
			waitDivFlashObj.setAttribute ('width', 175);
			waitDivFlashObj.setAttribute ('height', 125);
			waitDivFlashEmbed.setAttribute ('width', 175);
			waitDivFlashEmbed.setAttribute ('height', 125);
		}

		inner.appendChild (this.waitDivFlash.childNodes[0]);

		// waitDivInner TXT
		if (this.msg != undefined) {
			waitdivtxt = document.createElement ('p');
			waitdivtxt.innerHTML = this.msg;
			inner.appendChild (waitdivtxt);
		}

		document.body.appendChild (this.bg);

		this.div.appendChild (inner);
		this.parentNode.appendChild (this.div);

		// waitDiv - pozycjonowanie
		myHeight (this.div, this.height);

		// waitDivBg - pozycjonowanie
		//myHeight (this.bg, this.height);

		// waitDivInner - pozycjonowanie
		var scroller = myScrollSize();

		var innerL = Math.floor(this.centerX - myWidth(inner)/2 + scroller[0]),
			innerT = Math.floor(this.centerY - myHeight(inner)/2 + scroller[1])-50;

		myLeft (inner, innerL);
		myTop (inner, innerT);
		mySetStyle (inner, {'visibility':'visible'});

		myLeft (this.bg, innerL+10);
		myTop (this.bg, innerT+10);

		myWidth (this.bg, myWidth(inner));
		myHeight (this.bg, myHeight(inner));
	},

	show: function (msg) {
		this.msg = msg;
		if (this.div) {
			mySetStyle (this.div, {'display':'block'});
			mySetStyle (this.bg, {'display':'block'});
		} else
			this.create();
		this.hideSelectBoxes ();
	},

	hide: function () {
		if (this.div) {
			mySetStyle (this.div, {'display':'none'});
			mySetStyle (this.bg, {'display':'none'});
			this.showSelectBoxes ();
		}
	},

	hideSelectBoxes: function () {
		var selects = this.parentNode.getElementsByTagName("select"),
			i, imax;
		for (i=0, imax=selects.length; i<imax; i++)
			mySetStyle (selects[i], {'visibility':'hidden'});
	},

	showSelectBoxes: function () {
		var selects = this.parentNode.getElementsByTagName("select"),
			i, imax;
		for (i=0, imax=selects.length; i<imax; i++)
			mySetStyle (selects[i], {'visibility':'visible'});
	}
};
