// JavaScript Document

//obiekt ktry posuzy do odebrania informacji o kontrahencie
var kotrahentXmlHttpRequest = createXmlHttpRequestObject();

var odb_nab_ajax = createXmlHttpRequestObject();

//dla setTimeout
var kotrahentTimeoutId = -1;

//tagi jakie maja zostac wyuskane z opdebranego dokumentu XML
var kontrahentTagi = ['id', 'short_name', 'full_name', 'taxid', 'country', 'zipcode', 'place', 'street', 'building_number', 'apartment_number', 'blokada', 'blokada_powod', 'cena_id', 'rabat_id', 'platnik', 'sposob_zap' ];

var cena_old = null;

function kontrahentHandleResponse(){
  //po ukoczeniu procesu, decyduje co zrobi z otrzymanymi danymi
  if (kotrahentXmlHttpRequest.readyState == 4){
    // tylko jeli status dania HTTP jest "OK"
    if (kotrahentXmlHttpRequest.status == 200){
      try{
        //czyszcze
        if( kotrahentTimeoutId != -1 ){
            clearTimeout(kotrahentTimeoutId);
            kotrahentTimeoutId = -1;
        }
        // zakada now tablic z nazwami funkcji
        var dane = new Object();
        
        if( kotrahentXmlHttpRequest.responseXML ){
            // pobiera element dokumentu
            var xmlRoot = kotrahentXmlHttpRequest.responseXML.documentElement;

            // sprawdza, czy s wyniki dla szukanego sowa kluczowego
            if(xmlRoot.childNodes.length){
                /* pobieramy nowe nazwy funkcji z pliku XML w postaci tablicy */
                var el = null;
                for(var i = 0; i < kontrahentTagi.length; i++){
                    //pobieram tag
                    el = xmlRoot.getElementsByTagName(kontrahentTagi[i]).item(0);
                    //jeslinie jest pusty
                    if( el.firstChild &&  el.firstChild.data ){
                        dane[kontrahentTagi[i]] = el.firstChild.data;
                    }else{
                        dane[kontrahentTagi[i]] = '';
                    }
                }
            }
        }

        if( dane['blokada'] == 1 ){
            alert('Ten odbiorca zosta zablokowany w kartotece kontrahentw, powd: ' + dane['blokada_powod'] );
            return false;
        }
        
        return dane;
      }
      catch(e){
          // wywietla komunikat o bdzie
          displayError(e.toString() + "\n" + kotrahentXmlHttpRequest.responseText );
      }
    }else{
        displayError("Wystpi problem podczas pobierania danych:\n" + kotrahentXmlHttpRequest.responseText);
    }
  }
} //end przygotujDane()

function getKontrahent(oref, contact_id){
  if(kotrahentXmlHttpRequest){
    try{
      /* jeli obiekt XMLHttpRequest nie jest zajty obsug poprzedniego dnia... */
      if (kotrahentXmlHttpRequest.readyState == 4 || kotrahentXmlHttpRequest.readyState == 0){
        //debug.pisz('cze sie z adresem: kontrahenci1.php?id='+ contact_id);

          kotrahentXmlHttpRequest.open("GET", SUGGEST_URL + '?action=k&id='+ contact_id, true);
          kotrahentXmlHttpRequest.onreadystatechange = function(){
              var dane = kontrahentHandleResponse();

              if( dane && dane['id'] > 0 ){
                  if( typeof( oref ) == 'string' ){
                      if( oref == 'o' ){
                          odbiorcaUpdateKontrahent(dane);
                      }else if( oref == 'n'){
                          nabywcaUpdateKontrahent(dane);
                      }
                  }else if( typeof( oref ) == 'object' ){
                      if( oref && oref.updateKontrahent ){
                          oref.updateKontrahent(dane);
                      }else{
                          alert('Spodziewano si obiektu!');
                      }
                  }
              }
        };
        
        kotrahentXmlHttpRequest.send(null);
      }else{// jeli jest zajty...
        //this.debugDevice.pisz('Serwer jest zajty dla sowa: ' + keyword);
        // czyci poprzednio ustawione czasy
        if( kotrahentTimeoutId != -1 ){
            clearTimeout(kotrahentTimeoutId);
            kotrahentTimeoutId = -1;
        }

        // ponawia prb po 0.5 sekundy
        kotrahentTimeoutId = setTimeout(function(){ getKontrahent(oref, contact_id) }, 500);
      }
    }catch(e){
      alert("Nie mog poczy si z serwerem:\n" + e.toString());
    }
  }
}


function odbiorcaUpdateKontrahent( dane ){
    var f = document.forms['zamowienie_form'];

    for( var i in dane ){
        if( f['odbiorca_' + i]  )
            f['odbiorca_' + i].value = dane[i];
    }

/*
    var zastap = true;
    if(  f.nabywca_short_name.value != '' && f.nabywca_id.value != f.odbiorca_id.value){
        if(!confirm('Dane nabywcy zostay wypenione czy chcesz je zastapi?')){
            zastap = false;
        }
    }

    if(zastap){
        for(var i in dane){
          f['nabywca_' + i].value = dane[i];
        }
    }
*/

    for(var i in dane){
        if( f['nabywca_' + i]  ){
            f['nabywca_' + i].value = dane[i];
        }
    }
    
    if( parseInt(dane['sposob_zap']) > 0 ){
        select_option(f['SPOSOB_PLATNOSCI' ], dane['sposob_zap']);
    }
    
    if( parseInt(dane['cena_id']) > 0 ){
        select_option(f['cena_id' ], dane['cena_id']);
        
    }
    
    if( parseInt(dane['rabat_id']) > 0 ){
        select_option(f['rabat_id' ], dane['rabat_id']);
    }
    
    if( parseInt(dane['platnik']) > 0 ){
        setTimeout( function(){ getKontrahent('n', dane['platnik']); }, 100 );
    }
    
    //ustawiam w koszyku mobilnego handlowca odbiorce i po ustawienu pobieram aktywne alarmy
    server_connect( odb_nab_ajax, MAIN_URL +'?action=koszyk&mode=set&ajax=1&odbiorca_id=' + dane['id'], function(){ get_alarmy( dane['id'], 'w'); } );
    
    server_connect( odb_nab_ajax, KONTRAHENCI_URL +'?mode=ajax&adresy=1&ID=' + dane['id'], odbiorca_adresy_response );
}


function nabywcaUpdateKontrahent( dane ){
    var f = document.forms['zamowienie_form'];

    for(var i in dane){
        if( f['nabywca_' + i]  ){
            f['nabywca_' + i].value = dane[i];
        }
    }

    if( parseInt(dane['cena_id']) > 0 ){
        select_option(f['cena_id' ], dane['cena_id']);
    }

    if( parseInt(dane['rabat_id']) > 0 ){
        select_option(f['rabat_id' ], dane['rabat_id']);
    }
    
    if( parseInt(dane['sposob_zap']) > 0 ){
        select_option(f['SPOSOB_PLATNOSCI' ], dane['sposob_zap']);
    }

    //ustawiam w koszyku mobilnego handlowca nabywce i po ustawienu pobieram aktywne alarmy
    server_connect( odb_nab_ajax, MAIN_URL +'?action=koszyk&mode=set&ajax=1&nabywca_id=' + dane['id'], on_set_odb_nab );
}

function on_set_odb_nab( odp ){
    if( arguments.length > 1 ){
        //nie udao sie ustawic
        alert('Nie udao si ustawi kontrahenta na zamwieniu.');
    }else if( odp == 'OK' ){
        get_alarmy( document.forms['zamowienie_form']['nabywca_id'].value, 'w');
    }else{
        alert('Uwaga! Spodziewano si odpowiedzi z serwera: "OK", natomiast otrzymano: ' + odp );
    }
}

function odbiorca_update( id, short_name ){
    setTimeout( function(){ getKontrahent('o', id); }, 10 );
   
}

function nabywca_update(id, short_name ){
    setTimeout( function(){ getKontrahent('n', id); }, 10 );
}

var o_rabat_przelicz_div = null;
function rabat_onchange( o_sel ){
    if( !o_rabat_przelicz_div ){
        o_rabat_przelicz_div = document.getElementById('rabat_przelicz_div');
    }
    
    o_rabat_przelicz_div.style.display = 'block';
    
    if( o_sel.value != '' ){
        server_connect( odb_nab_ajax, MAIN_URL +'?action=koszyk&mode=set&ajax=1&rabat_id=' + o_sel.value, rabat_set_response);
        
        
    }
}

var o_cena_przelicz_div = null;
function cena_onchange( o_sel ){
    if( !o_cena_przelicz_div ){
        o_cena_przelicz_div = document.getElementById('cena_przelicz_div');
    }

    o_cena_przelicz_div.style.display = 'block';
    
    if( o_sel.value != '' ){
        server_connect( odb_nab_ajax, MAIN_URL +'?action=koszyk&mode=set&ajax=1&cena_id=' + o_sel.value, cena_set_response);

        
    }
}


function odbiorca_adresy_response( o_xml ){
    var o_form = document.forms['zamowienie_form'];

    var adresy = new Object();

    var adres_id, adres_nazwa, o_adres_xml, o_adres, attr;
    var o_adresy_xml = o_xml.getElementsByTagName('adres');
    var j;
    
    var attrs = [ 'ID', 'ZIPCODE', 'PLACE', 'STREET', 'BUILDING_NUMBER', 'APARTMENT_NUMBER'  ];

    for( j = 0; j < o_adresy_xml.length; j++){
        o_adres_xml = o_adresy_xml[j];
        o_adres = new Object();
        
        for( i=0; i < attrs.length; i++ ){
            attr = attrs[i];
            o_adres[attr] = o_adres_xml.getAttribute( attr );
        }

        adres_nazwa = o_adres.ZIPCODE + ' ' + o_adres.PLACE + ' ' +
                      ( o_adres.STREET.match(/^\s*ul[\. ]/i) ? o_adres.STREET : 'ul. ' + o_adres.STREET )  + ' ' +
                      o_adres.BUILDING_NUMBER +
                      ( (o_adres.APARTMENT_NUMBER == '') ? '' : ' lok. ' + o_adres.APARTMENT_NUMBER );
        
        adresy[o_adres.ID] = adres_nazwa;
    }

    make_select( o_form.elements['ADRES_DOSTAWY'], adresy );

}

function adres_onchange( o_sel ){
    server_connect( odb_nab_ajax, MAIN_URL +'?action=koszyk&mode=set&ajax=1&adres_id=' + o_sel.value, adres_set_response);
}

function adres_set_response( odp ){
    if( arguments.length > 1 ){
        alert('Nie udao si ustawi adresu wysyki w zamwieniu.');
    }else if( odp != 'OK' ){
        alert('Uwaga! Spodziewano si odpowiedzi z serwera: "OK", natomiast otrzymano: ' + odp );
    }
}

function rabat_set_response( odp ){
    if( arguments.length > 1 ){
        alert('Nie udao si ustawi rabatu dla pozycji zamwienia.');
    }else if( odp != 'OK' ){
        alert('Nie udao si ustawi rabatu dla pozycji zamwienia! Spodziewano si odpowiedzi z serwera: "OK", natomiast otrzymano: ' + odp + '. Skorzystaj z przycisku ustaw!' );
    }
}


function cena_set_response( odp ){
    if( arguments.length > 1 ){
        alert('Nie udao si ustawi ceny dla pozycji zamwienia.');
    }else if( odp != 'OK' ){
        alert('Nie udao si ustawi ceny dla pozycji zamwienia! Spodziewano si odpowiedzi z serwera: "OK", natomiast otrzymano: ' + odp + '. Skorzystaj z przycisku ustaw!' );
    }
}



function zamowienie_wyslij(){
    var o_form = document.forms['zamowienie_form'];
    
    if( o_form.elements['rabat_przelicz'].checked ){
        if( confirm('Zmienie rabat i zaznaczye opcj przeliczenia rabatu dla towarw znajdujcyhc sie w cenniku. Kliknij OK jeli chcesz przeliczy ceny anuluj aby zoy zamwienie bez przeliczania. ') ){
            o_form.elements['mode'].value = 'set';
        }
    }else if( o_form.elements['cena_przelicz'].checked ){
        if( confirm('Zmienie cen i zaznaczye opcj przeliczenia cen dla towarw znajdujcych sie w koszyku. Kliknij OK jeli chcesz przeliczy ceny, anuluj aby zoy zamwienie bez przeliczania. ') ){
            o_form.elements['mode'].value = 'set';
        }
    }
    
    o_form.submit();
}


function oferta_wyslij(){
    var o_form = document.forms['zamowienie_form'];

    o_form.elements['action'].value = 'of';
    o_form.elements['mode'].value = 'add';
    
    if( o_form.elements['rabat_przelicz'].checked ){
        if( confirm('Zmienie rabat i zaznaczye opcj przeliczenia rabatu dla towarw znajdujcyhc sie w cenniku. Kliknij OK jeli chcesz przeliczy ceny anuluj aby zoy zamwienie bez przeliczania. ') ){
            o_form.elements['mode'].value = 'set';
        }
    }else if( o_form.elements['cena_przelicz'].checked ){
        if( confirm('Zmienie cen i zaznaczye opcj przeliczenia cen dla towarw znajdujcych sie w koszyku. Kliknij OK jeli chcesz przeliczy ceny, anuluj aby zoy zamwienie bez przeliczania. ') ){
            o_form.elements['mode'].value = 'set';
        }
    }

    o_form.submit();

}
