/*Element typu textarea w ktrym bede wypisywa komunikaty*/
var debug_ = null;
/* URL do strony PHP, ktra poda podpowiedzi dla danego sowa kluczowego*/
var getFunctionsUrl = "kontrahenci.php?PHPSESSID=" + SESSSION_ID + "&keyword=";
/* URL ktry pokae wyniki wywietlane dla wybranej podpowiedzi */
var phpHelpUrl="http://www.php.net/manual/en/function.";
/* sowo kluczowe, dla ktrego wywoujemy danie HTTP*/
var httpRequestKeyword = "";
/* ostatnie sowo kluczowe, dla ktrego wysyano danie*/
var userKeyword = "";
/* ilo podpowiedzi pojawiajcych si dla danego sowa kluczowego*/
var suggestions = 0;
/* maksymalna liczba znakw wywietlanych w podpowiedzi*/
var suggestionMaxLength = 30;
/* flaga, ktra wskazuje, czy uytkownik skorzysta ze strzaek w gr lub w d podczas ostatniego zdarzenia keyup*/
var isKeyUpDownPressed = false;
/* ostatnia podpowied uyta do autouzupeniania sowa kluczowego*/
var autocompletedKeyword = "";
/* flaga, ktra okrela, czy s wyniki dla obecnego sowa kluczowego*/
var hasResults = false;
/* identyfikator uywany do odwoania procesu oceny (metoda Timeout)*/
var timeoutId = -1;
/* obecnie wybrana (mysz lub strzakami) podpowied*/
var position = -1;
/* obiekt pamici podrcznej, zawierajcy podpowiedzi pobrane dla rnych sw kluczowych*/
var oCache = new Object();
/* minimalna i maksymalna pozycja widocznych podpowiedzi*/
var minVisiblePosition = 0;
var maxVisiblePosition = 9;
// wartoc true owoduje wywietlenie szczegowego komunikatu o bdzie
var debugMode = true;
/* obiekt XMLHttpRequest, stworzony do komunikowania si z serwerem*/
var xmlHttpGetSuggestions = createXmlHttpRequestObject();
/* funkcja init obsuguje zdarzenie onload*/
window.onload = init;

/* funkcja inicjujca stron*/
function init() 
{  
  // pobiera element kontrolujcy sowo kluczowe podane na wejciu
  var oKeyword = document.getElementById("keyword");    
  // zapobiega uruchomieniu domylnego autouzupeniania przegldarki
  oKeyword.setAttribute("autocomplete", "off");  
  // czyci zawarto sowa kluczowego i ustawia kursor w okienku tekstowym
  oKeyword.value = "";
  oKeyword.focus();
  // czas, po ktrym sprawdza si, czy nastpiy zmiany w polu tekstowym
  setTimeout("checkForChanges()", 500);
}


 
/* funkcja, ktra dodaje sowo kluczowe do tablicy wartoci */
function addToCache(keyword, values)
{
  // twrzy nowy wpis w tablicy pamici podrcznej
  oCache[keyword] = new Array();
  // dodaje nowe wartoci sw kluczowych do pamici
  for(i=0; i<values.length; i++)
    oCache[keyword][i] = values[i];
}


/* funkcja, ktra sprawdza, czy sowo kluczowe jest ju w pamici lub prbuje
znale najdusze przedrostki z pamici do niego pasujce. Nastpnie dodaje
je do pamici, jako odpowiadajce wpisanemu sowu kluczowemu */
function checkCache(keyword)
{
  // sprawdza, czy sowo kluczowe jest ju w pamici
  if(oCache[keyword])
    return true;
  var keyword_lower = keyword.toLocaleLowerCase();

  // prbuje odnale najduszy przedrostek
  for(i=keyword.length-2; i>=0; i--)
  {
    // uzupenia biece sowo kluczowe
    var currentKeyword = keyword.substring(0, i+1);
    // sprawdza, czy biecy przedrostek sowa kluczowego jest ju w pamici
    if(oCache[currentKeyword])
    {
      // jeli jest w pamici
      var cacheResults = oCache[currentKeyword];
      // wyniki odpowiadajce biecemu sowu kluczowemu
      var keywordResults = new Array();
      var keywordResultsSize = 0;
      // prbuje odnale wszystkie sowa pasujce do biecego przedrostka
      for(j=0; j < cacheResults.length; j++)
      {
        if( (cacheResults[j].toLocaleLowerCase()).indexOf(keyword_lower) == 0)
          keywordResults[keywordResultsSize++] = cacheResults[j];
      }
      // dodaje wszystkie przedrostki sowa kluczowego do pamici
      addToCache(keyword, keywordResults);
      return true;
    }
  }
  // nie znaleziono funkcji
  return false;
}



/* pocztkuje danie HTTP, w celu pobrania podpowiedzi dla wpisanego sowa kluczowego */
function getSuggestions(keyword) 
{  
  /* kontynuuje, jeli wpisano jakie znaki i ostatnio wcinitym klawiszem nie bya jedna z pionowych strzaek*/
  if( keyword.length >= 1 && !isKeyUpDownPressed )
  {

    // sprawdza, czy sowo jest w pamici
    isInCache = checkCache(keyword);
    // jeli jest...
    if(isInCache == true)          
    {   
      // pobiera wyniki z pamici
      httpRequestKeyword=keyword;
      userKeyword=keyword;     
      // wywietla wyniki 
      displayResults(keyword, oCache[keyword]); 
    }
    // jeli go nie ma w pamici, wysya nowe danie HTTP
    else    
    {    
      if(xmlHttpGetSuggestions)
      {
        try
        {
          /* jeli obiekt XMLHttpRequest nie jest zajty obsug poprzedniego dnia... */
          if (xmlHttpGetSuggestions.readyState == 4 || 
              xmlHttpGetSuggestions.readyState == 0) 
          {    
            httpRequestKeyword = keyword;
            userKeyword = keyword;
            if(debugMode)
                debug('cz sie z serwerem. Z nastpujcym adresem: ' + getFunctionsUrl + encode(keyword) );
            xmlHttpGetSuggestions.open("GET", getFunctionsUrl + encode(keyword), true);
            xmlHttpGetSuggestions.onreadystatechange = handleGettingSuggestions; 
            xmlHttpGetSuggestions.send(null);
          }
          // jeli jest zajty...
          else
          {
            // pobiera sowo, ktre wpisa uytkownik
            userKeyword = keyword;
            // czyci poprzednio ustawione czasy
            if(timeoutId != -1)
              clearTimeout(timeoutId); 
            // ponawia prb po 0.5 sekundy     
            timeoutId = setTimeout("getSuggestions(userKeyword);", 500);
          }
        }
        catch(e)
        {
          displayError("Nie mog poczy si z serwerem:\n" + e.toString());
        }
      }
    }    
  }
}
/* przeksztaca wszystkie obiekty potomne wza XML na tablic*/
function xmlToArray(resultsXml)
{
  // pocztkuje zmienn resultsArray
  var resultsArray= new Array();  
  // przeszukuje w ptli wszystkie wzy XML, pobierajc ich zawarto
  for(i=0; i < resultsXml.length; i++)
    resultsArray[i] = resultsXml.item(i).firstChild.data;
  // zwraca zawarto wza w postaci tablicy
  return resultsArray;
}


/*  obsuguje odpowied serwera, zawierajc podpowiedzi dla danego sowa kluczowego */
function handleGettingSuggestions() 
{
  //po ukoczeniu procesu, decyduje co zrobi z otrzymanymi danymi
  if (xmlHttpGetSuggestions.readyState == 4) 
  {
    // tylko jeli status dania HTTP jest "OK"
    if (xmlHttpGetSuggestions.status == 200) 
    { 
      try
      {
        // przetwarza odpowied serwera
        updateSuggestions();
      }
      catch(e)
      {
        // wywietla komunikat o bdzie
        displayError(e.toString()); 
      }  
    } 
    else
    {
      displayError("Wystpi problem podczas pobierania danych:\n" +
        xmlHttpGetSuggestions.statusText);
    }       
  }
}

/* funkcja przetwarzajca odpowied serwera */
function updateSuggestions()
{
  // pobiera odpowied serwera
  var response = xmlHttpGetSuggestions.responseText;
  // bd serwera?
  if (response.indexOf("ERRNO") >= 0 || response.indexOf("error:") >= 0
    || response.length == 0)
    throw(response.length == 0 ? "Void server response." : response);
  // pobiera element dokumentu
  response = xmlHttpGetSuggestions.responseXML.documentElement;
  // zakada now tablic z nazwami funkcji
  nameArray = new Array();
  // sprawdza, czy s wyniki dla szukanego sowa kluczowego
  if(response.childNodes.length)
  {
    /* pobieramy nowe nazwy funkcji z pliku XML w postaci tablicy */
    nameArray= xmlToArray(response.getElementsByTagName("name"));       
  }
  // sprawdza, czy s ju poszukiwane inne sowa kluczowe 
  if(httpRequestKeyword == userKeyword)    
  {
    // wywietla tablic wynikw
    displayResults(httpRequestKeyword, nameArray);
  }
  else
  {
    // dodaje wyniki do pamici
    // nie trzeba wywietla wynikw, poniewa s ju niepotrzebne
    addToCache(httpRequestKeyword, nameArray); 
  }
}

/* zapenia list podpowiedziami*/
function displayResults(keyword, results_array) 
{  
  // rozpoczyna tworzenie tabeli HTML, w ktrej umiecimy wyniki
  var div = "<table>"; 
  // jeli poszukiwane sowo kluczowe nie znajduje si w pamici, dodaje je do niej
  if(!oCache[keyword] && keyword)
    addToCache(keyword, results_array);
  // jeli tablica wynikw jest pusta, wywietla komunikat
  if(results_array.length == 0)
  {
    div += "<tr><td>Nie znaleziono dopasowania dla <strong>" + keyword + "</strong></td></tr>";
    // ustawia flag braku wynikw i zeruje licznik
    hasResults = false;
    suggestions = 0;
  }
  // wywietla wyniki
  else
  {
    // przestawia indeks wyrnionej podpowiedzi
    position = -1;
    // przestawia flag okrelajc, czy wcinito ktr ze strzaek
    isKeyUpDownPressed = false;
    /* ustawia flag informujc o dopasowania funkcji do podanego sowa kluczowego */
    hasResults = true;
    // pobiera z pamici liczb wynikw
    suggestions = oCache[keyword].length;
    // przeglda w ptli wyniki i tworzy ich list w HTML
    for (var i=0; i < oCache[keyword].length; i++)
    {  
      // pobiera biec nazw funkcji
      crtFunction = oCache[keyword][i];
      // ustawia acuch odnonika do dopasowanej funkcji na jej nazw
      crtFunctionLink = crtFunction;
      // zastpuje znak _ w acuchu odnonika znakiem - 
      while(crtFunctionLink.indexOf("_") !=-1)
        crtFunctionLink = crtFunctionLink.replace("_","-");
      // zaczyna tworzy rzd tabeli HTML, ktry zawiera odnonik do oficjalnej strony z pomoc dotyczc szukanej funkcji
      div += "<tr id='tr" + i + "' onclick='handleOnMouseClick(this);' onmouseover='handleOnMouseOver(this);' " +
        "onmouseout='handleOnMouseOut(this);'>" + "<td align='left'><a id='a" + i +"' ";
        
      // sprawdza czy dugo nazwy wybranej funkcji przekracza dopuszczaln liczb znakw, ktre mog by wywietlone
      if(crtFunction.length <= suggestionMaxLength)
      {
        // pogrubia dopasowany przedrostek funkcji i sowa kluczowego
        div += "'><b>" + crtFunction.substring(0, httpRequestKeyword.length) + "</b>"
        div += crtFunction.substring(httpRequestKeyword.length, crtFunction.length) +
          "</a></td></tr>";
      }
      else
      {
        // sprawdza czy dugo nazwy wybranego sowa kluczowego przekracza
        //dopuszczaln liczb znakw, ktre mog by wywietlone
        if(httpRequestKeyword.length < suggestionMaxLength)
        {
          /* pogrubia dopasowany przedrostek funkcji i sowa kluczowego */
          div += "'><b>" + crtFunction.substring(0, httpRequestKeyword.length) + "</b>"
          div += crtFunction.substring(httpRequestKeyword.length, suggestionMaxLength) +
            "</a></td></tr>";   
        }
        else
        {
          // pogrubia ca nazw funkcji
          div += "'><b>" + crtFunction.substring(0,suggestionMaxLength) + "</b></td></tr>"
        }
      }
    }
  }
  // koniec tabeli HTML
  div += "</table>";
  // pobiera obiekty oSuggest i oScroll
  var oSuggest = document.getElementById("suggest");  
  var oScroll = document.getElementById("scroll");
  // przewija na gr listy
  oScroll.scrollTop = 0;
  // aktualizuje i wywietla list podpowiedzi
  oSuggest.innerHTML = div;
  oScroll.style.visibility = "visible";
  // jeli byy jakie wyniki uzupeniamy sowo kluczowe do wartoci pierwszej funkcji
  if(results_array.length > 0)
    autocompleteKeyword();      
}

/* funkcja, ktra okresowo sprawdza, czy wprowadzono zmiany w oknie tekstowym */
function checkForChanges()
{
  // pobiera obiekt sowa kluczowego
  var keyword = document.getElementById("keyword").value;
  // sprawdza, czy sowo kluczowe jest puste
  if( keyword.length < 1 )
  {
    // ukrywa podpowiedzi
    hideSuggestions();
    // czyci sowo kluczowe
    userKeyword = "";
    httpRequestKeyword = "";
  }
  // ustawia licznik czasu dla nowego sprawdzenia
  setTimeout("checkForChanges()", 500);
  // sprawdza, czy wprowadzono zmiany 
  if((userKeyword != keyword) && (autocompletedKeyword != keyword) &&
    (!isKeyUpDownPressed))
    // aktualizuje podpowied
    getSuggestions(keyword);
}

/* funkcja obsugujca wcinicie klawisza*/
function handleKeyUp(e) 
{
  // pobiera zdarzenie
  e = (!e) ? window.event : e;
  // pobiera adresata zdarzenia
  target = (!e.target) ? e.srcElement : e.target;
  if (target.nodeType == 3) 
    target = target.parentNode;
  // pobiera kod znaku nacinitego klawisza
  code = (e.charCode) ? e.charCode :
       ((e.keyCode) ? e.keyCode :
       ((e.which) ? e.which : 0));
  // sprawdza, czy zdarzenie byo typu  keyup
  if (e.type == "keyup") 
  {    
    isKeyUpDownPressed = false;
    // sprawdza, czy pojawi si ktry z wanych dla aplikacji znakw
    if ((code < 13 && code != 8) || (code >=14 && code < 32 && code != 27) ||
      (code >= 33 && code <= 46 && code != 38 && code != 40) ||
      (code >= 112 && code <= 123)) 
    {
      // ignoruje pozostae znaki
    }
    else
    /* po wciniciu klawisza Enter, przechodzi do strony pomocy PHP dla danej funkcji */
    if(code == 13)
    {
      // sprawdza, czy jaka funkcja jest wanie wybrana
      if(position >= 0)
      {
        updateKeywordValue(document.getElementById("tr" + position));
        hideSuggestions();
      }
      try{
        e.stopPropagation();
      }
      catch(err){}
      e.cancelBubble = true;
      e.returnValue = false;
    }
    //po wcisnieciu klawisza 27
    else if(code == 27){
        hideSuggestions();
    }
    else
    // po naciniciu strzaki w d przechodzi do kolejnej podpowiedzi
      if(code == 40)
      {                   
        newTR=document.getElementById("tr"+(++position));
        oldTR=document.getElementById("tr"+(--position));
        // usuwa stary wybr
        if(position>=0 && position<suggestions-1)
          oldTR.className = "";
 
        // wybiera now podpowied i aktualizuje sowo kluczowe
        if(position < suggestions - 1)
        {
          newTR.className = "highlightrow";
          updateKeywordValue(newTR);
          position++;         
        }     
        e.cancelBubble = true;
        e.returnValue = false;
        isKeyUpDownPressed = true;        
        // przewija podpowiedzi w d, jeli widoczne okno nie jest ju aktualne
        if(position > maxVisiblePosition)
        {   
          oScroll = document.getElementById("scroll");
          oScroll.scrollTop += 18;
          maxVisiblePosition += 1;
          minVisiblePosition += 1;
        }
      }
      else
      // nacinicie strzaki w g przenosi nas do poprzedniej podpowiedzi
      if(code == 38)
      {       
        newTR=document.getElementById("tr"+(--position));
        oldTR=document.getElementById("tr"+(++position));
        // usuwa stare zaznaczenie
        if(position>=0 && position <= suggestions - 1)
        {       
          oldTR.className = "";
        }
        // zaznacza now podpowied i aktualizuje sowo kluczowe
        if(position > 0)
        {
          newTR.className = "highlightrow";
          updateKeywordValue(newTR);
          position--;
          // przewija okno w gr, jeli dane w nim s ju nieaktualne
          if(position<minVisiblePosition)
          {
            oScroll = document.getElementById("scroll");
            oScroll.scrollTop -= 18;
            maxVisiblePosition -= 1;
            minVisiblePosition -= 1;
          }   
        }     
        else
          if(position == 0)
            position--;
        e.cancelBubble = true;
        e.returnValue = false;
        isKeyUpDownPressed = true;  
      }     
  }
}


/* funkcja uzupeniajca sowo kluczowe do waroci wybranej podpowiedzi */
function updateKeywordValue(oTr)
{
  // pobiera obiekt sowa kluczowego
  var oKeyword = document.getElementById("keyword");
  // pobiera odnonik do wybranej funkcji
  var crtLink = document.getElementById("a" + oTr.id.substring(2,oTr.id.length)).toString();
  //pobieram sam tekst ze znacznika tr
  var slowo = oTr.innerHTML.replace(/<[^>]+>/g, '');
  
  if (debugMode)
    debug('Aktualizuje sowo! ' + crtLink + ' ' + slowo);
    
    var str= 'Wasnoci element oTR: \n';
    var i = null;
    for(i  in oTr){
        str += i + ' = ' + oTr[i] + '\n';
    }

  if (debugMode)
    //debug(str);

  oKeyword.value = slowo;
  
  //to pozostaosc z poprzedniego skryptu jeszce nie usuwalem
  //crtLink = crtLink.substring(0, crtLink.length - 4);
  // aktualizuje sowo kluczowe
  //oKeyword.value = decode(crtLink.substring(phpHelpUrl.length, crtLink.length));
  //oKeyword.value = oKeyword.value.toLocaleString();
  //oKeyword.value = crtLink.substring(phpHelpUrl.length, crtLink.length);
}


/* funkcja usuwajca styl podpowiedzi */
function deselectAll()
{ 
  for(i=0; i<suggestions; i++)
  {
    var oCrtTr = document.getElementById("tr" + i);
    oCrtTr.className = "";    
  }
}


/* funkcja obsugujca pojawienie si kursora myszy w obszarze podpowiedzi */
function handleOnMouseClick(oTr)
{
    updateKeywordValue(oTr);
    hideSuggestions();
    position = oTr.id.substring(2, oTr.id.length);
}

/* funkcja obsugujca pojawienie si kursora myszy w obszarze podpowiedzi */
function handleOnMouseOver(oTr)
{
  deselectAll();  
  oTr.className = "highlightrow";  
  position = oTr.id.substring(2, oTr.id.length);
}


/* funkcja obsugujca wyjcie kursora myszy z obszaru podpowiedzi */
function handleOnMouseOut(oTr)
{
  oTr.className = "";   
  position = -1;
}

/* funkcja sterujca acuchem */
function encode(uri) 
{

  if (encodeURIComponent)
  {
    return encodeURIComponent(uri);
  }

  if (escape)
  {
    return escape(uri);
  }
  
}


function decode(uri){
  var zamiana = [
        [/%20/ig, ' '],
        [/%B1/ig, ''], [/%A1/ig, ''],
        [/%EA/ig, ''], [/%CA/ig, ''],
        
        [/%E6/ig, ''], [/%C6/ig, ''],
        [/%B6/ig, ''], [/%A6/ig, ''],
        [/%BC/ig, ''], [/%AC/ig, ''],
        [/%BF/ig, ''], [/%AF/ig, ''],
        [/%B3/ig, ''], [/%A3/ig, ''],
        [/%F3/ig, ''], [/%D3/ig, ''],
        [/%F1/ig, ''], [/%D1/ig, ''],
  ];
  
  var i = null;
  for(i = 0; i < zamiana.length; i++){
    uri = uri.replace(zamiana[i][0], zamiana[i][1])
  }
  return uri;

  //Dalsza czesc tej funkcji le dekoduje znaki nie to kodowanie
  if (decodeURIComponent)
  {
    try{
        uri = decodeURIComponent(uri);
        if (debugMode)
            debug('Cig po odkodowaniu funckj: decodeURIComponent' + uri);
        return uri;
    }
    catch(e){
        debug('Bd zwrcony przez decodeURIComponent:  ' + e.toString());
    }
    //return decodeURIComponent(uri);
  }

  if (unescape)
  {
    uri = unescape(uri);
    if (debugMode)
        debug('Ciag po odkodowaniu funckj: unescape: ' + uri);
    return unescape(uri);
  }
  
}
/* funkcja ukrywajca warstw z popdpowiedziami */
function hideSuggestions()
{
  var oScroll = document.getElementById("scroll");
  oScroll.style.visibility = "hidden";  
}

/* funkcja, ktra wybiera obszar w obiekcie tekstowym, przekazywanym jako jej parametr */
function selectRange(oText, start, length)
{  
  // sprawdz rodzaj przegldarki - IE czy FF
  if (oText.createTextRange) 
  {
    //IE
    var oRange = oText.createTextRange(); 
    oRange.moveStart("character", start); 
    oRange.moveEnd("character", length - oText.value.length); 
    oRange.select();
  }
  else 
    // FF
    if (oText.setSelectionRange) 
    {
      oText.setSelectionRange(start, length);
    } 
  oText.focus(); 
}

/* funkcja uzupeniajca wpisane sowo kluczowe */
function autocompleteKeyword()
{
  //pobiera obikt sowa kluczowego
  var oKeyword = document.getElementById("keyword");
  // zeruje pozycj zaznaczonej podpowiedzi
  position=0;
  // usuwa zaznacznie ze wszystkich odpowiedzi
  deselectAll();
  // podwietla wybran podpowied
  document.getElementById("tr0").className="highlightrow";  
  // uzupenia sowo kluczowe do podpowiedzi
  updateKeywordValue(document.getElementById("tr0"));  
  // stosuje odpowiedni styl 
  selectRange(oKeyword,httpRequestKeyword.length,oKeyword.value.length);  
  // ustawia uzupenione sowo jako warto sowa kluczowego
  autocompletedKeyword=oKeyword.value;
}

/* funkcja wywietlajca komunikat o bdzie */
function displayError(message)
{
  // wywietla komunikat bdu - bardziej szczegowy jeli debugMode ma warto true
  alert("Bd podczas dostpu do serwera! " + (debugMode ? "\n" + message : ""));
}

function debug(msg){

    if(!debug_){
        debug_ = document.getElementById('debug');
    }
    debug_.value += msg + "\n";
}

function strtolower(str){
    str.toLowerCase();
    return str;
}

function print_r(el){
    var i = null;
    var str = '';
    for(i in el){
        str += i + ' = ' + el[i] + '\n';
    }
    debug(str);
}



var okno = false;

function print_r( zmienna, nazwa, wciecie ){
    var tab  = "&nbsp;&nbsp;&nbsp;&nbsp;";

    if( !okno ){
        okno = window.open("","okienko");
        okno.document.open();
        okno.focus();
    }

    switch(typeof(zmienna)){

    case "number":
        if( nazwa ){
            okno.document.writeln( wciecie + nazwa + " = " + zmienna + ";<br>");
        }else{
            okno.document.writeln( wciecie + zmienna );
        }

    break;

    case "string":
        if( nazwa ){
            okno.document.writeln( wciecie + nazwa + " = " + zmienna + ";<br>");
        }else{
            okno.document.writeln( wciecie + zmienna );
        }

    break;

    case "boolean":
        if( nazwa ){
            okno.document.writeln( wciecie + nazwa + " = " + zmienna+ ";<br>");
        }else{
            okno.document.writeln( wciecie + zmienna );
        }
    break;

    case "object":
    //object lub array
        if(typeof(zmienna.length) != "undefined" ){
            typ = "Array( <br>";
        }else{
            typ = "Object( <br>";
        }
        if( nazwa ){
            okno.document.writeln( wciecie + nazwa + " " + typ);
        }else{
            okno.document.writeln( wciecie + typ );
        }

        for( var i in zmienna){
            print_r( zmienna[i], i, wciecie+tab );
        }
        okno.document.writeln( wciecie + "); <br>" );

    break;

    case "function":
        if( nazwa != "" ){
            okno.document.writeln( wciecie + "function " +nazwa + "(){<br>}<br>");
        }else{
            okno.document.writeln( wciecie + "function(){}" );
        }

    break;

    case "undefined":
        if( nazwa != "" ){
            okno.document.writeln( wciecie + nazwa + " = " + "undefined<br>");
        }else{
            okno.document.writeln( wciecie + "undefined<br>" );
        }
    break;

    }//end switch
}
