// JavaScript Document
function Cache(){
    //
    this.oCache = new Object();
}

/* funkcja, ktra dodaje sowo kluczowe do tablicy wartoci */
Cache.prototype.add = function(keyword, values)
{
  // twrzy nowy wpis w tablicy pamici podrcznej
  this.oCache[keyword] = new Array();
  // dodaje nowe wartoci sw kluczowych do pamici
  for(var i = 0; i < values.length; i++)
    this.oCache[keyword][i] = values[i];
}


/* funkcja, ktra sprawdza, czy sowo kluczowe jest ju w pamici lub prbuje
znale najdusze przedrostki z pamici do niego pasujce. Nastpnie dodaje
je do pamici, jako odpowiadajce wpisanemu sowu kluczowemu */
Cache.prototype.check = function (keyword)
{
  // sprawdza, czy sowo kluczowe jest ju w pamici
  if(this.oCache[keyword])
    return true;

  var keyword_lower = keyword.toLocaleLowerCase();

  // prbuje odnale najduszy przedrostek
  for(var i = keyword.length-2; i>=0; i--)
  {
    // uzupenia biece sowo kluczowe
    var currentKeyword = keyword.substring(0, i+1);
    // sprawdza, czy biecy przedrostek sowa kluczowego jest ju w pamici
    if(this.oCache[currentKeyword])
    {
      // jeli jest w pamici
      var cacheResults = this.oCache[currentKeyword];
      // wyniki odpowiadajce biecemu sowu kluczowemu
      var keywordResults = new Array();
      var keywordResultsSize = 0;
      // prbuje odnale wszystkie sowa pasujce do biecego przedrostka
      for(var j=0; j < cacheResults.length; j++)
      {
        if( (cacheResults[j].toLocaleLowerCase()).indexOf(keyword_lower) == 0)
          keywordResults[keywordResultsSize++] = cacheResults[j];
      }
      // dodaje wszystkie przedrostki sowa kluczowego do pamici
      this.add(keyword, keywordResults);
      return true;
    }
  }
  // nie znaleziono funkcji
  return false;
}

Cache.prototype.get = function(keyword){
  return this.oCache[keyword];
}

