/******************************************************************************/
/****                                Tables                                ****/
/******************************************************************************/

CREATE DOMAIN SMS_TRESC_D AS VARCHAR(640) CHARACTER SET WIN1250 COLLATE WIN1250;

CREATE GENERATOR WWW_SMS_LOG_ID_GEN;

CREATE TABLE WWW_SMS_LOG (
    ID        INTEGER NOT NULL,
    MODUL     VARCHAR(128),
    NUMER     STRING20_D /* STRING20_D = VARCHAR(20) */,
    TRESC     SMS_TRESC_D /* SMS_TRESC_D = VARCHAR(640) */,
    WYNIK     BLOB SUB_TYPE 1 SEGMENT SIZE 512,
    CDATE     TIMESTAMP,
    ADRES_IP  ADRES_IP_D /* ADRES_IP_D = VARCHAR(15) DEFAULT '0.0.0.0' */
);




/******************************************************************************/
/****                             Primary Keys                             ****/
/******************************************************************************/

ALTER TABLE WWW_SMS_LOG ADD CONSTRAINT WWW_SMS_LOG_PK PRIMARY KEY (ID);


/******************************************************************************/
/****                               Triggers                               ****/
/******************************************************************************/


SET TERM ^ ;


/******************************************************************************/
/****                         Triggers for tables                          ****/
/******************************************************************************/



/* Trigger: WWW_SMS_LOG_BI */
CREATE TRIGGER WWW_SMS_LOG_BI FOR WWW_SMS_LOG
ACTIVE BEFORE INSERT POSITION 0
AS
BEGIN
  IF (NEW.ID IS NULL) THEN
    NEW.ID = GEN_ID(WWW_SMS_LOG_ID_GEN,1);
END
^


SET TERM ; ^



/******************************************************************************/
/****                              Privileges                              ****/
/******************************************************************************/


/* Privileges of roles */
GRANT ALL ON WWW_SMS_LOG TO WWW_ROLE;


ALTER TABLE WWW_ZK ADD ALARM_ID INTEGER;
alter table WWW_ZK add constraint WWW_ZK_ALARM_ID_FK foreign key (ALARM_ID) references R3_ALARMY(ID) on delete SET NULL on update CASCADE;


ALTER TABLE WWW_ZT ADD USER_ID INTEGER;

